/*
 * rst.h
 *
 *  Created on: 17.07.2015
 *      Author: AndreR
 *
 * Radio Server Team
 */

#ifndef RST_H_
#define RST_H_

#include "ch.h"
#include "util/flash_fs.h"
#include "protobuf-c/protobuf-c.h"
#include "constants.h"

typedef struct _RSTConfig
{
	uint8_t enabled;
	uint8_t rate;		// [Hz]
	uint16_t port;
} RSTConfig;

typedef struct _RST
{
	binary_semaphore_t semRun;

	RSTConfig cfg;
	FlashFile* pCfgFile;

	uint8_t pAllocBuf[RST_ALLOC_BUF_SIZE];
	size_t allocUsed;
	ProtobufCAllocator allocator;
} RST;

extern RST rst;

void RSTInit();
void RSTSetRate(uint8_t rate);
void RSTEnable(uint8_t enable);
void RSTSetPort(uint16_t port);
void RSTSaveConfig();
int16_t RSTInput(uint8_t* pData, uint16_t length);
void RSTTask(void* params);

#endif /* RST_H_ */
