/*
 * tft.c
 *
 *  Created on: 04.12.2012
 *      Author: AndreR
 */
#include "tft.h"

#include "util/init_hal.h"
#include "../constants.h"
#include "ch.h"

#define LCD_Panel_Data_Width				0//0:18bit; 1:24bit;
#define LCD_Pixel_Data_Interface_Format		3 // 16-bit (565 format)

void TFTWritePixel(uint32_t color)
{
	*TFT_DATA_REG = TFT_COLOR(color);
}

void TFTInit()
{
	GPIOInitData gpioInit;

	// Configure RESET Pin
	GPIOSet(GPIOG, GPIO_PIN_15);

	gpioInit.mode = GPIO_MODE_OUTPUT;
	gpioInit.otype = GPIO_OTYPE_PUSH_PULL;
	gpioInit.ospeed = GPIO_OSPEED_2MHZ;
	gpioInit.pupd = GPIO_PUPD_NONE;
	GPIOInit(GPIOG, GPIO_PIN_15, &gpioInit);

	FSMC_Bank1->BTCR[0] = FSMC_BCR1_MWID_0 | FSMC_BCR1_WREN;
	FSMC_Bank1->BTCR[1] = (3 << 8);	// DataSetupTime = 3
	FSMC_Bank1->BTCR[0] |= FSMC_BCR1_MBKEN;
}

void TFTSetBrightness(uint8_t level)
{
	// Set PWM config
	*TFT_CMD_REG = TFT_REG_SET_PWM_CONF;
	*TFT_DATA_REG = 0x0E;  // frequency
	*TFT_DATA_REG = level;  //  PWM duty cycle
	*TFT_DATA_REG = 0x01;  //  PWM enabled & PWM controlled by host
	*TFT_DATA_REG = 0x00;
	*TFT_DATA_REG = 0x00;
	*TFT_DATA_REG = 0x0F;
}
